/**
 * @file LiveServerMediaSubsession.hh
 * @author 吴晨
 * @brief 适配 live555
 * 
 * @copyright Copyright (c) 2022-2024 OurEDA
 */

#ifndef _LIVE_SERVER_MEDIA_SUBSESSION_HH
#define _LIVE_SERVER_MEDIA_SUBSESSION_HH

#include "OnDemandServerMediaSubsession.hh"

#include "BaseDeviceSource.hh"

class LiveServerMediaSubsession : public OnDemandServerMediaSubsession {
public:
    static LiveServerMediaSubsession *createNew(UsageEnvironment &env, codec_type_t codecType);
    BaseDeviceSource *deviceSource() { return fDeviceSource; }

protected:
    LiveServerMediaSubsession(UsageEnvironment &env, codec_type_t codecType);
    virtual ~LiveServerMediaSubsession();
    virtual FramedSource *createNewStreamSource(unsigned clientSessionId, unsigned &estBitrate);
    virtual RTPSink *createNewRTPSink(Groupsock *rtpGroupsock, unsigned char rtpPayloadTypeIfDynamic, FramedSource *inputSource);
    virtual void closeStreamSource(FramedSource* inputSource); 

private:
    codec_type_t fCodecType;
    BaseDeviceSource *fDeviceSource;
};
#endif
